<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfWSExtensibleBooking ArrayType
 * @subpackage Arrays
 */
class ArrayOfWSExtensibleBooking extends AbstractStructArrayBase
{
    /**
     * The WSExtensibleBooking
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\WSExtensibleBooking[]
     */
    public $WSExtensibleBooking;
    /**
     * Constructor method for ArrayOfWSExtensibleBooking
     * @uses ArrayOfWSExtensibleBooking::setWSExtensibleBooking()
     * @param \StructType\WSExtensibleBooking[] $wSExtensibleBooking
     */
    public function __construct(array $wSExtensibleBooking = array())
    {
        $this
            ->setWSExtensibleBooking($wSExtensibleBooking);
    }
    /**
     * Get WSExtensibleBooking value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\WSExtensibleBooking[]|null
     */
    public function getWSExtensibleBooking()
    {
        return isset($this->WSExtensibleBooking) ? $this->WSExtensibleBooking : null;
    }
    /**
     * This method is responsible for validating the values passed to the setWSExtensibleBooking method
     * This method is willingly generated in order to preserve the one-line inline validation within the setWSExtensibleBooking method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateWSExtensibleBookingForArrayConstraintsFromSetWSExtensibleBooking(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfWSExtensibleBookingWSExtensibleBookingItem) {
            // validation for constraint: itemType
            if (!$arrayOfWSExtensibleBookingWSExtensibleBookingItem instanceof \StructType\WSExtensibleBooking) {
                $invalidValues[] = is_object($arrayOfWSExtensibleBookingWSExtensibleBookingItem) ? get_class($arrayOfWSExtensibleBookingWSExtensibleBookingItem) : sprintf('%s(%s)', gettype($arrayOfWSExtensibleBookingWSExtensibleBookingItem), var_export($arrayOfWSExtensibleBookingWSExtensibleBookingItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The WSExtensibleBooking property can only contain items of type \StructType\WSExtensibleBooking, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set WSExtensibleBooking value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\WSExtensibleBooking[] $wSExtensibleBooking
     * @return \ArrayType\ArrayOfWSExtensibleBooking
     */
    public function setWSExtensibleBooking(array $wSExtensibleBooking = array())
    {
        // validation for constraint: array
        if ('' !== ($wSExtensibleBookingArrayErrorMessage = self::validateWSExtensibleBookingForArrayConstraintsFromSetWSExtensibleBooking($wSExtensibleBooking))) {
            throw new \InvalidArgumentException($wSExtensibleBookingArrayErrorMessage, __LINE__);
        }
        if (is_null($wSExtensibleBooking) || (is_array($wSExtensibleBooking) && empty($wSExtensibleBooking))) {
            unset($this->WSExtensibleBooking);
        } else {
            $this->WSExtensibleBooking = $wSExtensibleBooking;
        }
        return $this;
    }
    /**
     * Add item to WSExtensibleBooking value
     * @throws \InvalidArgumentException
     * @param \StructType\WSExtensibleBooking $item
     * @return \ArrayType\ArrayOfWSExtensibleBooking
     */
    public function addToWSExtensibleBooking(\StructType\WSExtensibleBooking $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\WSExtensibleBooking) {
            throw new \InvalidArgumentException(sprintf('The WSExtensibleBooking property can only contain items of type \StructType\WSExtensibleBooking, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->WSExtensibleBooking[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\WSExtensibleBooking|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\WSExtensibleBooking|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\WSExtensibleBooking|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\WSExtensibleBooking|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\WSExtensibleBooking|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string WSExtensibleBooking
     */
    public function getAttributeName()
    {
        return 'WSExtensibleBooking';
    }
}
