<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfWSFulldayAbsenceBlock ArrayType
 * @subpackage Arrays
 */
class ArrayOfWSFulldayAbsenceBlock extends AbstractStructArrayBase
{
    /**
     * The WSFulldayAbsenceBlock
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\WSFulldayAbsenceBlock[]
     */
    public $WSFulldayAbsenceBlock;
    /**
     * Constructor method for ArrayOfWSFulldayAbsenceBlock
     * @uses ArrayOfWSFulldayAbsenceBlock::setWSFulldayAbsenceBlock()
     * @param \StructType\WSFulldayAbsenceBlock[] $wSFulldayAbsenceBlock
     */
    public function __construct(array $wSFulldayAbsenceBlock = array())
    {
        $this
            ->setWSFulldayAbsenceBlock($wSFulldayAbsenceBlock);
    }
    /**
     * Get WSFulldayAbsenceBlock value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\WSFulldayAbsenceBlock[]|null
     */
    public function getWSFulldayAbsenceBlock()
    {
        return isset($this->WSFulldayAbsenceBlock) ? $this->WSFulldayAbsenceBlock : null;
    }
    /**
     * This method is responsible for validating the values passed to the setWSFulldayAbsenceBlock method
     * This method is willingly generated in order to preserve the one-line inline validation within the setWSFulldayAbsenceBlock method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateWSFulldayAbsenceBlockForArrayConstraintsFromSetWSFulldayAbsenceBlock(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfWSFulldayAbsenceBlockWSFulldayAbsenceBlockItem) {
            // validation for constraint: itemType
            if (!$arrayOfWSFulldayAbsenceBlockWSFulldayAbsenceBlockItem instanceof \StructType\WSFulldayAbsenceBlock) {
                $invalidValues[] = is_object($arrayOfWSFulldayAbsenceBlockWSFulldayAbsenceBlockItem) ? get_class($arrayOfWSFulldayAbsenceBlockWSFulldayAbsenceBlockItem) : sprintf('%s(%s)', gettype($arrayOfWSFulldayAbsenceBlockWSFulldayAbsenceBlockItem), var_export($arrayOfWSFulldayAbsenceBlockWSFulldayAbsenceBlockItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The WSFulldayAbsenceBlock property can only contain items of type \StructType\WSFulldayAbsenceBlock, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set WSFulldayAbsenceBlock value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\WSFulldayAbsenceBlock[] $wSFulldayAbsenceBlock
     * @return \ArrayType\ArrayOfWSFulldayAbsenceBlock
     */
    public function setWSFulldayAbsenceBlock(array $wSFulldayAbsenceBlock = array())
    {
        // validation for constraint: array
        if ('' !== ($wSFulldayAbsenceBlockArrayErrorMessage = self::validateWSFulldayAbsenceBlockForArrayConstraintsFromSetWSFulldayAbsenceBlock($wSFulldayAbsenceBlock))) {
            throw new \InvalidArgumentException($wSFulldayAbsenceBlockArrayErrorMessage, __LINE__);
        }
        if (is_null($wSFulldayAbsenceBlock) || (is_array($wSFulldayAbsenceBlock) && empty($wSFulldayAbsenceBlock))) {
            unset($this->WSFulldayAbsenceBlock);
        } else {
            $this->WSFulldayAbsenceBlock = $wSFulldayAbsenceBlock;
        }
        return $this;
    }
    /**
     * Add item to WSFulldayAbsenceBlock value
     * @throws \InvalidArgumentException
     * @param \StructType\WSFulldayAbsenceBlock $item
     * @return \ArrayType\ArrayOfWSFulldayAbsenceBlock
     */
    public function addToWSFulldayAbsenceBlock(\StructType\WSFulldayAbsenceBlock $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\WSFulldayAbsenceBlock) {
            throw new \InvalidArgumentException(sprintf('The WSFulldayAbsenceBlock property can only contain items of type \StructType\WSFulldayAbsenceBlock, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->WSFulldayAbsenceBlock[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\WSFulldayAbsenceBlock|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\WSFulldayAbsenceBlock|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\WSFulldayAbsenceBlock|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\WSFulldayAbsenceBlock|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\WSFulldayAbsenceBlock|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string WSFulldayAbsenceBlock
     */
    public function getAttributeName()
    {
        return 'WSFulldayAbsenceBlock';
    }
}
