<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for WSTaskRecipient StructType
 * @subpackage Structs
 */
class WSTaskRecipient extends AbstractStructBase
{
    /**
     * The id
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $id;
    /**
     * The person
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\WSLink
     */
    public $person;
    /**
     * The state
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $state;
    /**
     * The tsSeen
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\WSTimestamp
     */
    public $tsSeen;
    /**
     * The tsTransmitted
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\WSTimestamp
     */
    public $tsTransmitted;
    /**
     * The vehicle
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\WSVehicle
     */
    public $vehicle;
    /**
     * Constructor method for WSTaskRecipient
     * @uses WSTaskRecipient::setId()
     * @uses WSTaskRecipient::setPerson()
     * @uses WSTaskRecipient::setState()
     * @uses WSTaskRecipient::setTsSeen()
     * @uses WSTaskRecipient::setTsTransmitted()
     * @uses WSTaskRecipient::setVehicle()
     * @param int $id
     * @param \StructType\WSLink $person
     * @param string $state
     * @param \StructType\WSTimestamp $tsSeen
     * @param \StructType\WSTimestamp $tsTransmitted
     * @param \StructType\WSVehicle $vehicle
     */
    public function __construct($id = null, \StructType\WSLink $person = null, $state = null, \StructType\WSTimestamp $tsSeen = null, \StructType\WSTimestamp $tsTransmitted = null, \StructType\WSVehicle $vehicle = null)
    {
        $this
            ->setId($id)
            ->setPerson($person)
            ->setState($state)
            ->setTsSeen($tsSeen)
            ->setTsTransmitted($tsTransmitted)
            ->setVehicle($vehicle);
    }
    /**
     * Get id value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getId()
    {
        return isset($this->id) ? $this->id : null;
    }
    /**
     * Set id value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $id
     * @return \StructType\WSTaskRecipient
     */
    public function setId($id = null)
    {
        // validation for constraint: int
        if (!is_null($id) && !(is_int($id) || ctype_digit($id))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($id, true), gettype($id)), __LINE__);
        }
        if (is_null($id) || (is_array($id) && empty($id))) {
            unset($this->id);
        } else {
            $this->id = $id;
        }
        return $this;
    }
    /**
     * Get person value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\WSLink|null
     */
    public function getPerson()
    {
        return isset($this->person) ? $this->person : null;
    }
    /**
     * Set person value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\WSLink $person
     * @return \StructType\WSTaskRecipient
     */
    public function setPerson(\StructType\WSLink $person = null)
    {
        if (is_null($person) || (is_array($person) && empty($person))) {
            unset($this->person);
        } else {
            $this->person = $person;
        }
        return $this;
    }
    /**
     * Get state value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getState()
    {
        return isset($this->state) ? $this->state : null;
    }
    /**
     * Set state value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $state
     * @return \StructType\WSTaskRecipient
     */
    public function setState($state = null)
    {
        // validation for constraint: string
        if (!is_null($state) && !is_string($state)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($state, true), gettype($state)), __LINE__);
        }
        if (is_null($state) || (is_array($state) && empty($state))) {
            unset($this->state);
        } else {
            $this->state = $state;
        }
        return $this;
    }
    /**
     * Get tsSeen value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\WSTimestamp|null
     */
    public function getTsSeen()
    {
        return isset($this->tsSeen) ? $this->tsSeen : null;
    }
    /**
     * Set tsSeen value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\WSTimestamp $tsSeen
     * @return \StructType\WSTaskRecipient
     */
    public function setTsSeen(\StructType\WSTimestamp $tsSeen = null)
    {
        if (is_null($tsSeen) || (is_array($tsSeen) && empty($tsSeen))) {
            unset($this->tsSeen);
        } else {
            $this->tsSeen = $tsSeen;
        }
        return $this;
    }
    /**
     * Get tsTransmitted value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\WSTimestamp|null
     */
    public function getTsTransmitted()
    {
        return isset($this->tsTransmitted) ? $this->tsTransmitted : null;
    }
    /**
     * Set tsTransmitted value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\WSTimestamp $tsTransmitted
     * @return \StructType\WSTaskRecipient
     */
    public function setTsTransmitted(\StructType\WSTimestamp $tsTransmitted = null)
    {
        if (is_null($tsTransmitted) || (is_array($tsTransmitted) && empty($tsTransmitted))) {
            unset($this->tsTransmitted);
        } else {
            $this->tsTransmitted = $tsTransmitted;
        }
        return $this;
    }
    /**
     * Get vehicle value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\WSVehicle|null
     */
    public function getVehicle()
    {
        return isset($this->vehicle) ? $this->vehicle : null;
    }
    /**
     * Set vehicle value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\WSVehicle $vehicle
     * @return \StructType\WSTaskRecipient
     */
    public function setVehicle(\StructType\WSVehicle $vehicle = null)
    {
        if (is_null($vehicle) || (is_array($vehicle) && empty($vehicle))) {
            unset($this->vehicle);
        } else {
            $this->vehicle = $vehicle;
        }
        return $this;
    }
}
